import { Space, TableColumnsType, Tooltip } from "antd";
import { Question } from "../../types/Item";
import { FaPlus } from "react-icons/fa";
import { ModalEnum } from "../../enums/Model";
import { useObjectToEdit } from "../../zustand/ObjectToEditState";
import { RiDeleteBin6Fill } from "react-icons/ri";
import { MdOutlineEdit } from "react-icons/md";
import { useTranslation } from "react-i18next";
import { ABILITIES_ENUM } from "../../enums/abilities";
import { useNavigate } from "react-router-dom";
import { useModalState } from "../../zustand/Modal";
import {
  canAddQuestion,
  canDeleteQuestion,
  canEditQuestion,
} from "../../utils/hasAbilityFn";

export const useColumns = () => {
  const { setObjectToEdit } = useObjectToEdit((state) => state);
  const navigate = useNavigate();
  const { setIsOpen } = useModalState((state) => state);

  const handelAdd = () => {
    setObjectToEdit({});
    navigate(`${ABILITIES_ENUM?.QUESTION}/add`);
  };

  const handelDelete = (data: any) => {
    setObjectToEdit(data);
    setIsOpen(ModalEnum?.QUESTION_DELETE);
  };

  const handleEdit = (record: any) => {
    setObjectToEdit(record);
    navigate(`${ABILITIES_ENUM?.QUESTION}/${record?.id}`);
  };
  const [t] = useTranslation();

  const columns: TableColumnsType<Question> = [
    {
      title: t("columns.id"),
      dataIndex: "id",
      key: "id",
      align: "center",
      render: (text, record) => record?.id,
    },
    {
      title: `${t("columns.content")}`,
      dataIndex: "name",
      key: "name",
      align: "center",
      render: (text, record) => record?.content,
      ellipsis: true,
    },
    {
      title: t("columns.isBase"),
      dataIndex: "isBase",
      key: "isBase",
      align: "center",
      render: (text, record) =>
        record?.isBase ? t("practical.yes") : t("practical.no"),
    },
    {
      title: `${t("columns.question_options_count")}`,
      dataIndex: "name",
      key: "name",
      align: "center",
      render: (text, record) => record?.question_options_count,
    },
    {
      title: canAddQuestion ? (
        <button onClick={() => handelAdd()} className="add_button">
          {t("practical.add")} {t("models.Question")} <FaPlus />
        </button>
      ) : (
        ""
      ),
      key: "actions",
      align: "end",
      className: "custom_add_button_column",
      render: (text, record, index) => {
        const className =
          index % 2 === 0 ? "even-row buttonAction" : "odd-row buttonAction";

        return (
          <Space size="middle" className={className}>
            {canEditQuestion && (
              <Tooltip
                placement="top"
                title={t("practical.edit")}
                color="#E0E0E0"
              >
                <span onClick={() => handleEdit(record)}>
                  <MdOutlineEdit size={22} style={{ color: "#A098AE" }} />
                </span>
              </Tooltip>
            )}
            {canDeleteQuestion && (
              <RiDeleteBin6Fill
                onClick={() => handelDelete(record)}
                size={22}
                style={{ color: "#C11313" }}
              />
            )}
            {/* {can_show_Question && (
        
              <BsEyeFill
                onClick={() => handelShow(record)}
                size={22}
                style={{ color: "green" }}
              />
           
                )} */}
          </Space>
        );
      },
    },
  ];

  return columns;
};
